# VMD
## My poster
- Poster title "Comparison of structural representations for machine learning-enhanced DFT of impurity embeddings".
- Poster abstract on event website - posters - wasmer. [URL](https://www.cecam.org/workshop-details/1093).
- Poster abstract in my abstracts list. [URL](https://iffmd.fz-juelich.de/DZhVoK1VS_KooFBBNluYEQ#2021-07-20-CECAM-VMD21).
- Poster source, PDF, and abstract. Local file link `~/work/posters/2021-07-20_workshop_VMD21/`.
## My poster creation with inkscape

headline font: CMSSBX10
text font: CMSS17

header font size 52
text font 32

acknowledgements
header font size 44
text font size 24

formula links for VMD poster session:

**AI Meeting 2021-07-20 minutes or summary**

- Talk by @wasmer about his [VMD workshop
  poster](https://www.cecam.org/workshop-details/1093). Discussion about the
  usage of the [SOAP structural
  descriptor](https://singroup.github.io/dscribe/latest/tutorials/descriptors/soap.html)
  - @wasmer said the feature vectors / fingerprints produced by the descriptor
    for his dataset are ~99% sparse. reason: high number of chemical species in
    dataset combined with invariance guarantees made by the descriptor.
  - @wortmann noted that in this structural representation are many more
    features than samples / structures in this problem. Wouldn't it be sensible
    to try to find a less general representation more suited to this problem to
    reduce the descriptor size.
  - @kovacik suggested to look at [chemenv to identify coordination
    environments](https://iffchat.fz-juelich.de/pgi-1/pl/uo61kuf1zjnafry1rohunr96ey),
    which
# Talks

## Tim Würger
Q: Why was this interesting?

A:
- they compute SOAP matrix and visualize for structure similarity comparison. i
  could use this too! ask for code maybe. exchem github repo only has the
  website visualization code, not the data generation code.
- they use sketch-map (ceriotti 2011) for dimred visualization. see their
  poster.

links:
- http://www.exchem.de/
- https://sketchmap.org/
- https://www.nature.com/articles/s41529-020-00148-z
- https://uppsala.app.box.com/s/9bs8nood3ut8pi5iegc5sw9jvr1swyjx older poster.
  formula for SOAP similarity matrix.
- https://twuerger.com/projects/structure-property-relationships

## Joerg Behler

questions:

1. Why use only NN and not estimator?
2. For the local atomic energy outputs, instead of using multiple NNs with one
output for different species, could one also use one NN with multiple outputs
for each atomic energy?



# Posters

Interesting posters: see ods file.

## patrick reiser kit GNN Keras SchNet
Q: Why was this interesting?

A:
- implementation of GNNs like SchNet (Schütt et al. ~2019) (and others) for Keras
- reiser:you input the finite atomistic system as a graph. for crystals e.g. fully
  connected if small enough (same thing as SchNet does, though 60 atoms, such as
  in some of my impurity clusters might be a bit much).
- wasmer: potentially simpler than starting with SchNetPack?
- reiser: right now still in ifancy, still have to build the graph by hand. but
  in future, potentially simpler. though they now also go the keras route.-
- wasmer: GNN learns features by itself?
- reiser: yes
- wasmer: can also output learned features like e.g. intermediate layers for CNN?
- reiser: more complicated. there are things like GNNExplainer for that.

links:
- https://www.sciencedirect.com/science/article/pii/S266596382100035X
- https://github.com/aimat-lab/gcnn_keras
- https://schnetpack.readthedocs.io/en/stable/
- https://www.google.com/search?gnn+explainer


## talks with wasmer poster visitors

### talk with hongbin zhang
zhang: suggested @wasmer to look at magpie, ie use also compositional
descriptors (chemical property descriptors) or combine with structural
descriptors (like DScribe). contact if interested. zahng had previously worked
in jülich also.

links:
- https://scholar.google.com/citations?user=0wWDRwgAAAAJ
- https://www.mawi.tu-darmstadt.de/tmm/theorie_magnetischer_materialen/staff_1/mitarbeiter_tmm_details_61888.en.jsp
- mapgpie: see my tools notes https://iffmd.fz-juelich.de/68Vn-YcuSWCun3bL_rJHXA?both#Neural-Networks
  - https://bitbucket.org/wolverton/magpie/commits/
  - https://bitbucket.org/wolverton/magpie/commits/
