

# general #

## johannes wednesday  9:25 AM##

[link](https://aiidatutorial-vir2020.slack.com/archives/C01710PN5S5/p1594193143019200)

### OP ###

- Johannes question Q1) wrt presentation Provenance and workflows in AiiDA:
  1) p.11: class AddAndMultiplyWorkchain:
  - constuctor: why does super() call AddAndMultiplyWorkchain and not
    WorkChain?
  - classe's add and multiply methods: what is self.ctx?- Johannes question Q2) wrt Hands-on sessions, section 3.6 Calculation results:
  - unitconverters.net says: -22.64836518 Ry = -308.14681833 eV, while aiida output says -308.14698329819 eV. why discrepancy? just due to round-off of print output?- Johannes question Q3) wrt section Hands-on session, section 3.6:
  - performed 3 runs: A) wrong scf params, B) correct but 'scf' calc, C) correct but 'vc-relax' calc
  - for run C), I specified B) as parent:

    restart_builder.metadata.label = 'Restart from PwCalculation<{}>'.format(calc_B.pk)
    calc_C = submit(restart_builder)
    

  - I expected the provenance A -> B -> C. but when generated graph, it showed A -> (B, C). why?- JW question Q4) wrt aiida_core documentation:
  - is there sth akin to a javadoc/doxygen/sphinx page for aiida_core? Didn't find anything on aiida.readthedocs.io. Maybe aiida.readthedocs.io > Subpackages?- JW question Q5) on fundamental design choices of aiida:
  Q5.1) why chose to design own provenance model instead of using e.g. W3C PROV model
  Q5.2) why for aiida DAG chose relational DB postgres instead of e.g. graph or triplestore database
  Q5.3) DB GUI interface in the works (would be much more convenient to many end users to navigate DB?)

### answer ###

sebastiaan huber  40 minutes ago
> constuctor: why does super() call AddAndMultiplyWorkchain and not
    WorkChain?This is an older snippet that still uses Python 2 syntax. In  Python 3 you can just do super().some_metho()  but in Python 2 you had to manually pass in the class name itself and a reference i.e. super(AddMultiplyWorkChain, cls).define(spec)    TLDR: you can now just use super().define(spec)
sebastiaan huber  38 minutes ago

     classe's add and multiply methods: what is self.ctx

The ctx is an attribute that all workchains have that is called the "context". It functions a bit like a dictionary and you can use it to store variables in such that you can access them between steps without having to "directly" pass them
sebastiaan huber  34 minutes ago
Q2:  the energies in Rydberg are converted to eV using the constants that are defined by the qe-tools package: https://github.com/aiidateam/qe-tools    We took those constants from the QE source code to make sure they are internally consistent. These constants do not match exactly the current CoDATA values, which is why you might see some discrepancies. We have an open issue on qe-tools to discuss this: https://github.com/aiidateam/qe-tools/issues/25   Feel free to join if you have suggestions
GitHubGitHub
aiidateam/qe-tools
A set of useful tools for Quantum ESPRESSO. Contribute to aiidateam/qe-tools development by creating an account on GitHub.
GitHubGitHub
Slight inconsistencies in physical constants · Issue #25 · aiidateam/qe-tools
See original issues on aiida-core and aiida-quantumespresso
sebastiaan huber  31 minutes ago
Q3: How did you exactly define the parent? Just through the metadata.label input? Because that is not considered by the provenance. That is just a human-readable label. To restart from a previous calculation, you should pass the remote_folder of the calculation as the parent_folder input. Something like:

parent_calc = load_node(pk)
builder = parent_calc.get_builder_restart()
builder.parent_folder = parent_calc.outputs.remote_folder
submit(builder)

sebastiaan huber  31 minutes ago
Note that you should also adapt the parameters input to set CONTROL['restart_mode]': 'restart' for example
sebastiaan huber  30 minutes ago
Q4: You can find the entire API documentation in the "Reference" section: https://aiida-core.readthedocs.io/en/latest/reference/apidoc/aiida.html
sebastiaan huber  27 minutes ago
Q5.1) in the early beginnings, the provenance was loosely modeled after the Open Provenance Model (https://openprovenance.org/) but during development we needed to diverge of this to fit our typical use cases. I was not there at the beginning of AiiDA so cannot answer if or why not W3C PROV model was considered at all
openprovenance.org
Provenance Web Services
Open Provenance Web Services and Applications
sebastiaan huber  25 minutes ago
Q5.2) I think this is also mostly due to practical reasons. For fast prototyping, the Django project was used that comes with an ORM and database layer. There was an attempt at some point to replace the database with Neo4j, but was abandoned due to lack of resources. Currently, I am not sure if graph databases would provide the level of customizability that we currently require, because even though the biggest part of what we store is a graph, there are quite some other things that AiiDA stores as well. This would definitely be interesting to investigate in the future.
sebastiaan huber  22 minutes ago
Q5.3) There is the Explore section on the Materials Cloud which provides exactly that: a graphical way of exploring the contents of an AiiDA provenance graph: https://www.materialscloud.org/explore/. You can explore the graphs of the projects that have been uploaded there, but you can also connect your own local database: https://www.materialscloud.org/explore/connect  You should just start the REST API using verdi restapi and paste the link into the form of that browser page and you get the same interface, as if you would have uploaded your database to the Materials Cloud, but it is just being served from your local machine
materialscloud.orgmaterialscloud.org
Materials Cloud
Materials Cloud is built to enable the seamless sharing and dissemination of resources in computational materials science, encompassing educational material, interactive tools, simulation services, and curated and raw data.
materialscloud.orgmaterialscloud.org
Materials Cloud
Materials Cloud is built to enable the seamless sharing and dissemination of resources in computational materials science, encompassing educational material, interactive tools, simulation services, and curated and raw data.


## claude coppex ##

Claude Coppex  7:32 PM
Can we stop a QE calculation softly like with prefix.EXIT?
Giovanni Pizzi  7:33 PM
Yes, if you control the plugin, you can decide which files to generate when you submit
7:34
but you cannot, via AiiDA (at least in the current version), inject this file while it's running
7:34
You can, however, in the case of QE, set the max_seconds flag to stop the calculation gracefully after a given # of seconds, before the scheduler kills it. We use it very often
7:34
Internally it works the same as prefix.EXIT
7:35
or, if you want, you can go to the supercomputer and put the file prefix.EXIT yourself, if you accept the consequences
7:35
In this specific case, it's OK, if you use the advanced aiida-quantumespresso workflows, AiiDA will detect that the calculation is not over, and create a restart (or, if you just submitted a calculation, it will parse it anyway)

## david sangalli ##

Davide Sangalli Yesterday at 10:23 AM
Hi all. A question related to "Aiida basics" 2.3.4.2 Data structures. There is the command "verdi data structure show --format ase <IDENTIFIER>" where IDENTIFIER=3a4b1270 reported in the webpage works. How do I get such identifier ?
4 replies
Casper Welzel Andersen  1 day ago
As @sebastiaan huber writes, the IDENTIFIER is either the PK or UUID of a Node.
To retrieve these, one can use the verdi CLI, or more appropriately the QueryBuilder (something you will go through and see today)
Davide Sangalli  1 day ago
Ok. I can get the PKs of the StructureData via the verdi process show PK  where I have the initial UIID=ce81c420 of the calculation. But not the UUID of the StructureData
sebastiaan huber  1 day ago
the PK and UUID are interchangeable though. If you have a PK you can do verdi node show PK for example, which will show the node's UUID, which you can also use for verdi node show UUID which will show exactly the same, since that PK and UUID reference the same node.
Davide Sangalli  24 hours ago
Ok, thanks

sebastiaan huber  10:25 AM
the IDENTIFIER is either the PK or the UUID of the node you want to visualize
10:26
How you get it depends. Typically you want to see the input or an output of a process, so if you have the PK of a calculationi that you ran, you can run verdi process show PK. This will show you all the inputs and outputs including their PK. For StructureData nodes you can use that PK in verdi data structure show (among other things0



Giovanni Pizzi  10:57 AM
Copying the info I put in the chat also here, since it's easier to read, probably:Let's say the PK of my CalcJobNode is 22For the inputs: verdi node repo dump 22 raw_inputs will put in the folders raw_inputs all the input files generated by AiiDA:

$ ls raw_inputs/
aiida.in  _aiidasubmit.sh

For the outputs: first do verdi process show 22, you'll get:

[...]
Outputs          PK  Type
-------------  ----  ----------
remote_folder    23  RemoteData
retrieved        24  FolderData
sum              25  Int

So the output retrieved data PK is 24. Then, I do:
verdi node repo dump 24 raw_outputs
and the retrieved outputs will be in the raw_outputs folder:

$ ls raw_outputs/
aiida.out  _scheduler-stderr.txt  _scheduler-stdout.txt

(edited)




Davide Sangalli Yesterday at 11:22 AM
If I do verdi process show 688  I get

Inputs      PK    Type  
----------  ----  -------------
pseudos
    Ca      526   UpfData
    Si      885   UpfData
    O       1528  UpfData
code        671   Code
kpoints     196   KpointsData
parameters  687   Dict
settings    1054  Dict
structure   1905  StructureDataOutputs                    PK  Type
-----------------------  ----  -------------
output_kpoints           1451  KpointsData
output_parameters        1564  Dict
output_structure          356  StructureData
output_trajectory_array   439  ArrayData
remote_folder             122  RemoteData

Now if I do kpoint = load_node(196)  it works (later I can do kpoint.get_kpoints_mesh()  ).
Instead if I do kpoint = load_node(1451) it does not work (I get error if I try kpoint.get_kpoints_mesh()), although they both are of type KpointsData
10 replies
Marnik  23 hours ago
Hi Davide! This can depend on the type of KpointsData . For some calculations, you don't use a mesh (e.g. a band structure calculation).
Marnik  23 hours ago
In this case, you can see the list of k-points using:

kpoint.get_kpoints()

Marnik  23 hours ago
This is explained here:
Marnik  23 hours ago
https://aiida-tutorials.readthedocs.io/en/latest/pages/2020_Intro_Week/sections/basics.html#kpointsdata
Davide Sangalli  23 hours ago
Ok. Basically, in case of a mesh I use .get_kpoints_mesh(print_list=True) while in case of a list I use .get_kpoints() . Silly question: Why not to just have a general .get_kpoints() which automatically does the proper thing depending on the "sub type" ?
Francisco Ramirez  23 hours ago
What do you mean by "do the right thing"? QE needs a regular mesh (x ej 6 x 6 x 6), if the kpoints node represent an irregular list of points then there is no much one can do, no?
Marnik  23 hours ago
I think it's because the mesh needs the structure to set up the list of k-points. Maybe @sebastiaan huber can comment?
sebastiaan huber  23 hours ago
This is indeed a bit of a misdesign of the KpointsData class which was one of the very first data classes designed for AiiDA. We have not improved it yet, because it would be backwards incompatible and would break a lot of existing code. There is an open issue for it and we might improve the current interface if we move the class outside of aiida-core for v2.0
Davide Sangalli  23 hours ago
Ok ok. It was just a picky detail. Thanks :+1:



Davide Sangalli Yesterday at 11:45 AM
I have the impression the size of the .aiida folder grows quickly. Is there a way to specify another path for the folder if I do not want it in my $HOME ?
6 replies
sebastiaan huber  23 hours ago
This is due to the repository being stored there, which contains all the files. When you setup a profile, you can specify the location of this repository on your local file system. There, for example, you can point it to a special big HDD disk that you have mounted
sebastiaan huber  23 hours ago
You can find the current location by doing verdi profile show. You should see a line with the key aiidadb_repository_uri followed by a path
sebastiaan huber  23 hours ago
There is no API to change the repository of an existing repository, but if you were to create a new profile you can choose where to store it
Davide Sangalli  23 hours ago
Ok.  For the new repo, is there a specific command, or it is asked at a certain point which path I'd like to use ?
sebastiaan huber  23 hours ago
you will be prompted for it. When you setup a new profile with verdi setup it will interactively ask you for all the necessary information, for example the database details and the location of the repository
sebastiaan huber  23 hours ago
note that with this command, you will need to have setup a PostgreSQL database yourself. You can also use verdi quicksetup instead which will try to do this for you, and you can specify a custom path with verdi quicksetup --repository /mnt/bigdisk/aiida_repsitory for example



## daniel king ##

Daniel King Today at 12:54 AM
Hi, I have a few general questions about AiiDA:

    Is there a way to easily make groups within ipython, or can it only be done effectively through the shell?
    Say you generate data within AiiDA and want to publish it– what do you actually attach to say, your SI? Do you list the UUIDs of the login nodes? Where are the nodes stored and for how long? Do you attach some big export file? What is the ultimate goal/product of AiiDA when it comes to making published data more available, and is the use of AiiDA primarily for facilitating high-throughput calculations or for data sharing?

(edited)
7 replies
christopher sewell  5 hours ago

     Is there a way to easily make groups within ipython, or can it only be done effectively through the shell?

Yep easy peasy; its all detailed in: https://aiida.readthedocs.io/projects/aiida-core/en/latest/howto/data.html#organizing-data
christopher sewell  5 hours ago

    Say you generate data within AiiDA and want to publish it

If you want to share data, the primary mechanism is with verdi export ;
to export all or just a sub-section of your data.
With verdi import we then aim to ensure this data will "always" be compatible with new versions of aiida-core, via maintaing schema migrations from version to version.
We will discuss this on Friday.Also on Friday, @Giovanni Pizzi will discuss https://archive.materialscloud.org/, where we provide a means of making published archives available.

    and is the use of AiiDA primarily for facilitating high-throughput calculations or for data sharing

So in a sense both. Automation is certainly a key goal, but also with the provinence tracking and data storage, we hope that this facilitates reproducible computations, such that people can take the workflows and data you produce and either re-run them or build on them to generate new analysis.
christopher sewell  5 hours ago
does that make sense?
Daniel King  3 hours ago
Yes! I guess my follow up questions are:
A) Are there  ways to establish the reproducibility of executables used in calculations? Executable outputs can depend on how the software is compiled, and with what flags, libraries,etc.
B) I’m still unclear about the nature of the nodes in AiiDA. It is said in the tutorial that these are stored in the “database”. Is the database stored in you local machine, or some global database? Is it an option? (sorry if this is a silly question). If it’s a gobal database, can it be mined?
C) If you do an verdi import, how do you configure things to run in the same way? Do you need to change a config file to point it towards the right executables? Are we going to do something like this in the tutorial? (edited) 
sebastiaan huber  2 hours ago
A) This is a very good point, and currently, AiiDA cannot guarantee the reproducibility of the results of individual calculation because AiiDA only stores the name of the executable. When you setup a code in AiiDA, you can additional metadata that may be important, such as the code version and the compilation settings and configuration. However, it will be difficult to capture everything that is important. The obvious solution to this problem is to use containers, like Docker or Singularity. There are plans in the work to add direct support for this technology in AiiDA. Together with containers, the reproducibillity of results should be guaranteed fully
sebastiaan huber  2 hours ago
B) The nodes are stored in a database and file repository. Where they are hosted depends on the configuration. As an example, for the virtual machine you have been using, both are stored on the VM itself, so they are completely private and nobody can access them. This is the common installation method for AiiDA where you install it on your personal machine and keep the database and file repository local on that machine. However, it is possible, and some research groups and centers use this, to connect to a centralized database server that is maybe shared by an entire group. All of this is fully configurable. So you can share as much or little as you want. Finally, if you want to share (part) of your database for a publication, you can use the export functionality to export part of your database as an export file. This can be uploaded anywhere or for example the Materials Cloud which comes with automatic graph visualization tools for the data and generated DOIs.
sebastiaan huber  2 hours ago
C) If you import an AiiDA export archive and it contains calculation jobs, you can in principle re-run them. The only thing you should do is recreate the "code". So let's say you imported a PwCalculation  which uses Quantum ESPRESSO's pw.x so should configure a Code in your database that points to a pw.x executable on a computer configured in AiiDA. This can be the localhost or some remote computer like a cluster. Then you can simply rerun the calculation using the restart builder as shown in the tutorial.


# issues #

## daniel king ##
Daniel King Yesterday at 4:27 AM
I have a couple questions:

    What is the difference between “run” and “submit”? How does aiida know which computer to submit to?
    Can someone help me figure out why the following code does not work for resubmitting:

“”"
failed_calculation = load_node(“595f7258-f8d6-4c53-ae4a-a88de91ae21c”)
restart_builder = failed_calculation.get_builder_restart()#Adjust the mistakes in the previous parameters
#And also add “restart_mode” keyword
parameters = restart_builder.parameters.get_dict()
parameters[“SYSTEM”][“mickeymouse”] = None
parameters[“SYSTEM”].pop(“mickeymouse”)
parameters[“ELECTRONS”][“electron_maxstep”] = 80
parameters[“ELECTRONS”][“conv_thr”] = 1e-10
parameters[“CONTROL”][“restart_mode”] = ‘restart’#Assign parameters to restart build
Dict = DataFactory(“dict”)
params = Dict(dict=parameters)
restart_builder.parameters = params#Add some restart folders/parameters/metadata
restart_builder.parent_folder = failed_calculation.outputs.remote_folder
restart_builder.parameters = Dict(dict=parameters)
restart_builder.metadata.label = “Restart from PwCalculation”
from aiida.engine import run
run(restart_builder)
“”"3. Is there a way to get the “outputcat”/“stdout” as a property of the failed node in ipython? It is a bit annoying having to debug between 3 separate shell commands (verdi process report <ID>, verdi process show <ID>, and verdi calcjob outputcat <ID>). Is there a way to do everything in ipython? (edited) 
7 replies
christopher sewell  1 day ago

     What is the difference between “run” and “submit”?

The key difference is that "run" is a blocking/synchronous function, meaning python has to wait until it is completed until preceding with the next part of the program, whereas "submit" is a non-blocking/asynchronous function, meaning that the calculation is sent to a separate daemon to run, then proceeds with the next part of the program. submit returns a "future" result; an object that does not yet contain the actual calculation result, but "promises" to some time in the future.
For quick computations you may just wish to use run, but obviously for computations that can take hours/days to run, you would use submit , then check back on the result later.
You will learn more about this in the workchain tutorial. (edited) 
christopher sewell  1 day ago

     How does aiida know which computer to submit to?

In your example here, the get_builder_restart will populate the restart_builder with restart_builder.code , the external code with which to run the calculation. Each code is directly linked to a computer: restart_builder.code.computer
christopher sewell  1 day ago

     Can someone help me figure out why the following code does not work for resubmitting

What is the actual error message you are seeing? (edited) 
christopher sewell  1 day ago

     Is there a way to do everything in ipython?

So there will be actual python API's behind each CLI command, which I can point you towards some, or you could even look at the source code, like: https://github.com/aiidateam/aiida-core/blob/develop/aiida/cmdline/commands/cmd_process.py
But also in ipython if you add ! before a command, it will run it as a shell command, e.g. !verdi process report 1 (edited) 
GitHubGitHub
aiidateam/aiida-core
The official repository for the AiiDA code. Contribute to aiidateam/aiida-core development by creating an account on GitHub.
christopher sewell  1 day ago
Also, top tip, you can use variables in your shell command, like:

pk = 940
!verdi node show {pk}

Daniel King  1 day ago
Great, thanks for all the tips! I didn’t know the one about putting ipython variables into bash like {}. Checking out the source code, it seems like some operations like “calcjob outputcat” are pretty nontrivial, so I guess I will stick to ! commands there.I figured out the error I was having– I guess having an input error doesn’t qualify as a “restartable” problem in the QE plugin? When I removed the “restart_mode” assignment everything went fine.
christopher sewell  1 day ago
Great :grin:
No "restartable" for QE is usually when for example your optimisation was ended prematurely due to the wall-time being reached on the HPC, and so it will use the remote folder from this calculation to start a new calculation, using the last  structure, etc from the failed calculation

## giovanni pizzi ##

Giovanni Pizzi  1:47 PM
Note for everyone: _ is a special character in like QueryBuilder queries. In like queries, we use SQL syntax: % means any character (like * in bash) and _ means a single character, like ? in bash. If you want to match a literal _, you need to escape it: 'like': r'tutorial\_%'. Note both the backslash, and the r in front of the string to avoid that python tries to interpret the backslash (other option, otherwise: 'like': 'tutorial\\_%'

# group b #

## rohit goswami ##
Rohit Goswami Jul 7th at 3:32 PM
How do these workflows interact with the traditional schedulers on HPC clusters? If I have a logical set of nodes, then I might not necessarily get the jobs I need at once and might have different configurations (high memory nodes) for parts of the workflow
1 reply
Rohit Goswami  1 day ago
To further clarify, logical set of nodes meaning a set of data and transform nodes

Hi @Rohit Goswami I am not sure if I understood your question correctly but I will try to answer: in AiiDA calculations that are run through a scheduler on some computer (for example an HPC cluster) are performed through "calculation jobs". When you launch such a job, you tell on which computer to run it, which you will have configured in AiiDA. Therefore AiiDA knows what scheduler the computer uses, and AiiDA will then take care of everything. It will create the submit script and submit it to the scheduler. It will then poll the scheduler at intervals to check if the job is done, and when that is the case, retrieve all the files and parse it. This is all automatic. When you launch the calculation job within AiiDA, you can specify how many nodes to use, how much walltime to request, and all other sorts of scheduler specific parameters.

Rohit Goswami Yesterday at 9:00 PM
I am a bit confused about the enhancement proposal guidelines, are those after an issue has been opened in aiida-core or instead of?
15 replies
christopher sewell  14 hours ago
these are for larger changes than just a single issue
christopher sewell  14 hours ago
so a signifigant change to a part of the aiida functionality, that needs discussion before implementing
Giovanni Pizzi  14 hours ago
Indeed - they are more for proposal of a new design, to discuss the design itself more than the implementation
Giovanni Pizzi  14 hours ago
so you discuss that first, and when it's agreed upon, one can break it down to smaller issues that are more implementation-oriented
Rohit Goswami  14 hours ago
Ah ok, so it makes sense to first open an issue for a feature request and then later (if at all) move to an AEP?
Giovanni Pizzi  14 hours ago
Yes
christopher sewell  14 hours ago
indeed, I guess it depends on the scope of the feature
Giovanni Pizzi  14 hours ago
In the sense that you avoid the risk of writing a long AEP for something that e.g. cannot be implemented, or can be achieved in a simpler way
Rohit Goswami  14 hours ago
That makes a lot of sense. I went with a feature request issue here: https://github.com/aiidateam/aiida-core/issues/4231
GitHubGitHub
External Process Checkpoints for WorkChains · Issue #4231 · aiidateam/aiida-core
I&#39;m not sure this problem is under the ambit of the AiiDA development roadmap Is your feature request related to a problem? Please describe Currently AiiDA keeps track of which jobs have been s...
christopher sewell  14 hours ago
thanks
Giovanni Pizzi  14 hours ago
Thanks, I wasn't aware of these libraries
Giovanni Pizzi  14 hours ago
I'm just wondering of how much this should be done by AiiDA, and how much by the application itself, and/or by the scheduler? I'm not an expert, so seeing an example of how this would be used (even without AiiDA, just a step-by-step example that I could rerun) would be useful to understand better
Rohit Goswami  14 hours ago
Well, the last time I looked into this was when BCLR was still considered, and back then it would dynamically hack into the executable and store as much of the state as possible.Of course the cleanest way is to have the application itself store all the variables it needs, e.g. having a default seed value set, but few if any bother to do this.
Rohit Goswami  14 hours ago
I will try to find a good example after the 15th and update the issue then
Giovanni Pizzi  13 hours ago
Sure, thanks a lot!
