import numpy as np
import matplotlib.pyplot as plt

def plot_potential_differences(V1, V2):
    diff = np.abs(V1 - V2)
    
    # Create 2D slices through the center of the 3D array
    slice_xy = diff[:, :, diff.shape[2]//2]
    slice_xz = diff[:, diff.shape[1]//2, :]
    slice_yz = diff[diff.shape[0]//2, :, :]
    
    fig, (ax1, ax2, ax3) = plt.subplots(1, 3, figsize=(18, 6))
    
    im1 = ax1.imshow(slice_xy, cmap='viridis')
    ax1.set_title('XY Slice')
    plt.colorbar(im1, ax=ax1)
    
    im2 = ax2.imshow(slice_xz, cmap='viridis')
    ax2.set_title('XZ Slice')
    plt.colorbar(im2, ax=ax2)
    
    im3 = ax3.imshow(slice_yz, cmap='viridis')
    ax3.set_title('YZ Slice')
    plt.colorbar(im3, ax=ax3)
    
    plt.tight_layout()
    plt.show()

# Usage:
# plot_potential_differences(V_p, V_p_v)
