import numpy as np

class YourClass:
    def __init__(self):
        # Your existing attributes
        self.a = 1
        self.b = "string"
        self.c = [1, 2, 3]
        self.d = np.array([1, 2, 3])
        self.e = {"key": "value"}
        
        # Large attributes to be excluded
        self.x = {"large": "dictionary"}
        self.y = SomeCustomClass()
        self.z = [1] * 1000000  # Large list

        # Store the ids of excluded attributes
        self._excluded_param_ids = {id(self.x), id(self.y), id(self.z)}

    def get_parameters(self) -> dict:
        """Return the potential's parameters.

        This amounts to all attributes that are not numerical potential data or
        explicitly excluded. In the potential file, these are the parameters in
        the file header.

        :return: dictionary of all parameters
        """
        return {k: v for k, v in self.__dict__.items()
                if not isinstance(v, (dict, np.ndarray)) and id(v) not in self._excluded_param_ids}

# Example usage
obj = YourClass()
params = obj.get_parameters()
print(params)
