import numpy as np

class YourClass:
    def __init__(self):
        # Your existing attributes
        self.a = 1
        self.b = "string"
        self.c = [1, 2, 3]
        self.d = np.array([1, 2, 3])
        self.e = {"key": "value"}
        
        # Attributes to be excluded
        self.x = "exclude me"
        self.y = "exclude me too"
        self.z = "also exclude me"

    def get_parameters(self) -> dict:
        """Return the potential's parameters.

        This amounts to all attributes that are not numerical potential data or
        explicitly excluded. In the potential file, these are the parameters in
        the file header.

        :return: dictionary of all parameters
        """
        excluded_attrs = {self.x, self.y, self.z}
        return {k: v for k, v in self.__dict__.items()
                if not isinstance(v, (dict, np.ndarray)) and v not in excluded_attrs}

# Example usage
obj = YourClass()
params = obj.get_parameters()
print(params)
