import matplotlib.pyplot as plt
import numpy as np
from ipywidgets import interact

def create_interactive_contour_plot(cpot):
    # Function to plot the contour at a given z-index
    def plot_contour(z_index):
        X = cpot.grid.meshgrids[0]
        Y = cpot.grid.meshgrids[1]
        V = cpot.grid.data
        
        plt.figure()
                    
        plt.contourf(X[:, :, z_index], Y[:, :, z_index], V[:, :, z_index])
        plt.colorbar()
        plt.title(f'Contour plot at z_index={z_index}')
        plt.xlabel('X')
        plt.ylabel('Y')
        plt.show()

    # Interactive widget to choose z-index
    interact(plot_contour, z_index=(0, cpot.grid.data.shape[2]-1))
