###### tags: `2023`, `FZJ`, `ZB`, `publishing`, `checklist`, `template`, `scientific publishing`, `academic publishing`

# The FZJ Publishing Checklist

# Description

Checklist template for paper publication for FZJ employees. Extracted without
modification from the original source, FZJ Intranet - Central Library (ZB) -
Expertise - The Scientific Publishing Process, state of last modification
2023-07-12. [URL](https://intranet.fz-juelich.de/en/organization/zb/expertise/scientific_publishing/process/publications_database).

Changelog.

- 2024-01-29. [J. Wasmer](https://www.fz-juelich.de/profile/wasmer_j). Extracted from original source (see description).
# How to use this template

How to use this template. Copy-paste the checklist template into your favorite
text editor, for example [iffMD](https://iffmd.fz-juelich.de/) (uses HackMD syntax; [features](https://iffmd.fz-juelich.de/features#)). Mark completed
items with `[X]`. Depending on your editor, super-items get completed
automatically. One example of very good support for this kind of thing is in the
editor Emacs org-mode ([manual](https://orgmode.org/manual/Checkboxes.html), [guide](https://orgmode.org/guide/Checkboxes.html)). Links to the things mentioned in the
checklist are in the original source, see above.

Versions.

- Org format. [URL](https://iffgit.fz-juelich.de/phd-project-wasmer/notes/public/-/blob/main/admin/publishing_notes/fzj-publishing-checklist/README.org).
- Markdown format on iffMD. [URL](https://iffmd.fz-juelich.de/nPosJxhUTZScs7bG3SLtmQ).

# Flowchart

![fzj-zb-scientific-publishing-process](https://iffmd.fz-juelich.de/uploads/9cf66a5116f030d7accc23d00.jpg)

*Figure reference: The scientific publishing process, flowchart. Courtesy of Central Library (ZB), Forschungszentrum Jülich. URL: https://intranet.fz-juelich.de/en/organization/zb/expertise/scientific_publishing/process. Accessed 2024-01-29.*

# Checklist

## Manuscript \[0/5\]

- [ ] Publish? – No, Exploit? - Yes. Pursue patent instead of publication.
  - Responsible: Head of institute. Involved: Author, project partners and co-authors, R-P, D, ZB.
  - [ ] Consult institute head on potential exploitation
  - [ ] Where applicable: consult project partners and co-authors on potential exploitation
  - [ ] Where applicable: contact R-P and D
- [ ] Literature searches
  - Responsible: Author. Involved: Co-authors, ZB.
  - [ ] Conduct comprehensive literature search on your research topic
- [ ] Manuscript planning
  - Responsible: Author. Involved: Institute head(s), co-authors, funders, ZB.
  - [ ] Publication medium is thematically appropriate
  - [ ] Publication medium is not predatory
  - [ ] Publication medium complies with the publication guidelines of the funders (e.g. Forschungszentrum Jülich, DFG)
  - [ ] Inform Project partners and co-authors of publication medium
- [ ] Manuscript writing
  - Responsible: Author. Involved: Project partners and co-authors, ZB, G-SG.
  - [ ] Compliance with journal template
  - [ ] Availability of rights of reuse for any illustrations reused
  - [ ] If applicable, linguistic revision of manuscript
- [ ] Manuscript approval
  - Responsible: Head of institute. Involved: Author, project partners and co-authors, R-P, R-R, UE, UK-E.
  - [ ] Ensure “Approval of Publications” form (assessments according to A 4.3 and B 1 of directive IR 251-2) has been signed
  - [ ] Correctness and completeness of author affiliations have been verified
  - [ ] All projects and funders (project number) are named in the acknowledgements
  - [ ] All project partners have been informed
  - [ ] If applicable, UK-E has been informed

## Publisher \[0/5\]

- [ ] Prepublication? – Yes. Preprint server
  - Responsible: Author. Involved: Project partners and co-authors, ZB, publisher
  - [ ] Inform project partners and co-authors
  - [ ] Inform institute head(s)
  - [ ] Verify publisher’s requirements
  - [ ] Prepare manuscript according to publisher’s requirements
  - [ ] Upload preprint version to preprint server
- [ ] Prepublication? – No. Submission
  - Responsible: Author. Involved: ZB, publisher
  - [ ] Illustrations available in sufficient resolution
  - [ ] Compliance with submission guidelines
  - [ ] Author affiliations complete
  - [ ] ORCID included
  - [ ] Cover letter include
  - [ ] Comply with any applicable publisher cooperation agreements
  - [ ] Submit manuscript
  - [ ] Save preprint
- [ ] Peer review
  - Responsible: Publisher. Involved: Author, co-authors, institute head(s), ZB
  - [ ] Inform co-authors and institute head(s) on status
  - [ ] Revise manuscript
  - [ ] Write response to reviewers’ comments
  - [ ] Submit response and revised manuscript
- [ ] Acceptance
  - Responsible: Publisher. Involved: Author, co-authors, institute head(s), ZB, UK-E
  - [ ] Inform co-authors, project partners, and institute head(s) of acceptance
  - [ ] Complete copyright agreement
  - [ ] Store post-print version safely and retrievably
  - [ ] If relevant, inform UK-E and involve your institute head(s), co-authors, and project partners on the potential for public relations work
- [ ] Publication Charges
  - Responsible: ZB, F. Involved: Author, co-authors, institute, funders, ZB, publisher
  - [ ] Forward invoice or link to invoice order form to zb-copyright@fz-juelich.de (include cost centre if required)
  - [ ] VAT information included
  - [ ] Invoice addressed to “Forschungszentrum Jülich GmbH” (include “Central Library” if applicable)
- [ ] Typesetting
  - Responsible: Publisher. Involved: Author, co-authors, G-SG
  - [ ] Verify that no errors were introduced into the publisher’s version
  - [ ] Verify quality and readability of illustrations
  - [ ] Transfer any manuscript changes to the post-print version
  - [ ] Save post-print version

## Publications database \[0/3\]

- [ ] Entry into JuSER
  - Responsible: Institute. Involved: Author, project partners and co-authors, ZB.
    - [ ] Import via DOI or other ID
    - [ ] Select whether VDB-relevant
    - [ ] Verify and confirm authors
    - [ ] Include all POF topics and grants
    - [ ] Enter all institutes involved
    - [ ] Verify correctness of data
    - [ ] Include abstract
    - [ ] Upload a PDF of the post-print version
    - [ ] Click “Finish & Release” to initiate workflow
- [ ] Online first? – Yes
  - Responsible: Publisher. Involved: Author, institute, ZB.
  - [ ] Complete any missing information
  - [ ] Complete the JuSER entry when the final version of the manuscript has been published, or contact ZB
- [ ] Online first? – No. JuSER release
  - Responsible: ZB. Involved: Author, co-authors, institutes.

## Outreach \[0/2\]

- [ ] Informing funders of publication
  - Responsible: Author. Involved: Project partners and co-authors, project management, funders, ZB.
  - [ ] Report the publication to all funders via the project manager
  - [ ] Report the publication to all project partners
- [ ] Public Relations
  - Responsible: Author and UK-E press officer involved. Involved:
    Institute head(s), if applicable: freelance authors (commissioned by
    UK-E), project partners and co-authors, press offices of cooperation
    partners, project management, funder, publisher.
  - [ ] Inform UK-E once the publication has been accepted
  - [ ] Clarify availability of scientists involved for any questions from the press after publication
- [ ] Reporting
  - Responsible: Institute head(s), project management. Involved: Author, project partners and co-authors, funder, ZB, UE.
  - [ ] Submit to JuSER
